//!
//! @file main.c,v
//!
//! Copyright (c) 2006 Atmel.
//!
//! @brief 啔 : ͖JԂɊÂ܂B
//!
//! @version 1.5
//!

//_____ ݸٰ _______________________________________________________________
#include "config.h"
#include "lib_mcu/compiler.h"
#include "lib_mcu/mcu.h"
#include "lib_mcu/adc/adc_drv.h"
#include "mc_interface.h"
#include "inavr.h"
#include <stdio.h>

//_____ ϸ ___________________________________________________________________

//_____ ` __________________________________________________________________
void   init(void);
void   ADC_Init(void);
void   ADC_start_conv(void);
void   ushell_task_init(void);
void   ushell_task(void);
void   PSC_Init(unsigned int ot0,  unsigned int ot1);
//void   PSC_Start(void);
U16    mc_control_speed_16b(U16 speed_ref , U16 speed_measure);
U16    get_Hall_Period(void);
void   store_new_amplitude(U16 new_val);
S16    read_acquisition(void);
void   Start_ADC(void);

//_____ 錾 __________________________________________________________________
volatile U8     Main_Tick = 0;		//!< ̂߂̎Iȸۯ
volatile S16    Ref_Speed = 0;		//!< gp҂̊x

extern volatile U8   Flag_IT_ADC;
extern volatile S16  User_Speed;
extern volatile U16  Measured_Speed;
extern volatile Bool mci_run_stop;


void main(void)
{
  init();
  ADC_Init();
  ushell_task_init();
  PSC_Init(2, MAX_PWM);
//  PSC_Start();	/* MC100p */

  while(1)
  {
	if (Main_Tick)
	{
	  Main_Tick=0;
//	  Start_ADC();

	  if (mci_run_stop == RUN)
	  {
		Ref_Speed = User_Speed;
	  }
	  else
	  {
		Ref_Speed = 0;
	  }

	  Set_PC1();
	  Measured_Speed = (U16)K_SPEED / get_Hall_Period();
	  mci_store_measured_speed((U8)Measured_Speed);

	#if (REGULATION_MODE == 2)
	  store_new_amplitude( mc_control_speed_16b((U16) Ref_Speed , (U16) Measured_Speed) );
	#else
	  if (mci_run_stop == RUN)
	  {
		store_new_amplitude( AMPLITUDE_IN_OPEN_LOOP );
	  }
	  else
	  {
		store_new_amplitude( 0 );
	  }
	#endif
	  Clear_PC1();
	  ushell_task();
	}

	if (Flag_IT_ADC)
	{
	  mci_store_measured_current(read_acquisition());
	  Flag_IT_ADC=0;
	}	/* Flag_IT_ADC̍Ō */

#ifdef MC200
	/* MC200ߓd͌ */
	if (( PIFR0 & (1<<PEV0A)) !=0 )
	{
	  /* ߓdł̌ */
	  Set_PC3();	/* ߓdLED_ */
	  Clear_PE1();	/* s/~LED */
	  while (1) ;	/* JԂ */
	}
#endif
  }	/* while(1)̍Ō */
}	/* main̍Ō */
